# Metadata server with kernel stack and LSM-tree backend

## Getting started
The folder code contains the HPDOS server and client implementation. To use them clone this repo.

HPDOS uses `gRPC` system calls with `protocol buffers` as the data exchange standard. The project is managed using `Gradle` project manager. As a first step, install the system requirements listed at the end of this section.

### Compile
To compile the codebase run `./gradlew build` separately from the client and server root directory. Gradle should take care of installing and managing any third party libraries used.

#### Steps to compile and execute metadata application
- **At the Server, run:**

    $ ./gradlew build

    $ ./gradlew installDist

    $ ./app/build/install/app/bin/app

- **At the Client, run:**

    $ ./gradlew build

    $ ./gradlew installDist

    $ ./app/build/install/app/bin/app <absolute-path>/app.config

### Clean
The project build generated files can be cleaned by running `./gradlew clean`

### System Requirements
- Java | OpenJDK 14.0+
- Gradle
    - To install gradle version
    
        https://linuxize.com/post/how-to-install-gradle-on-ubuntu-20-04/
- Protocol Buffer / Protobuf
