## mTCP for Bluefield smartNIC

### mTCP code changes
The material in "documentation" folder provides details on code changes required to run mTCP over Bluefield ARM cores.

### Configure and compile mTCP
1. Download and configure DPDK-19.11.8 using Alternative-2, as discussed in DPDK README
2. Setup the MTCP-DPDK environment; this involves integration of DPDK with mTCP

    a. $ export RTE_SDK=\<absolute-path-to-dpdk-stable-19.11.8\>
    
    b. $ export RTE_TARGET=arm64-bluefield-linuxapp-gcc //For Bluefield smartNIC  OR
        $ export RTE_TARGET=x86_64-native-linuxapp-gcc //For Host
        
    c. Configure mTCP with our DPDK version
    
    .../mtcp-devel$ ./configure --with-dpdk-lib=$RTE_SDK/$RTE_TARGET CFLAGS="-DMAX_CPUS=<num_host/nic_cpus>" 
    
    // Use --disable-hwcsum when working in virtualized environment
    
    // If there an error: “configure: error: Could not find gmp.h”;  $ sudo apt install libgmp-dev
        
    d. Integrate mTCP with our DPDK version
    
    <path-to-mtcp-devel>$ sudo ./setup_mtcp_dpdk_env.sh \<absolute-path-to-dpdk-stable-19.11.8\>
        
3. Compile mTCP
    
    .../mtcp-devel$ make -j

4. To revert back mTCP NIC changes
    <path-to-mtcp-devel>$ ./setup_linux_env.sh \<path to $RTE_SDK\>

### Configuration for executing mTCP sample application "HTTP server"
1. Configure static ARP entries

    .../mtcp-devel/apps/example/config$ vim arp.conf 

    //Add ARP entries for remote IPs (see example below)
    
        ARP_ENTRY 6
        192.168.200.10/32 0c:42:a1:df:ac:48
        192.168.210.10/32 0c:42:a1:df:ac:49
        192.168.200.20/32 0c:42:a1:df:ac:42
        192.168.210.20/32 0c:42:a1:df:ac:43
        192.168.200.30/32 0c:42:a1:df:ac:41
        192.168.210.30/32 0c:42:a1:df:ac:40
2. Configure static route entries 

    .../mtcp-devel/apps/example/config$ vim route.conf 
    
    //Add route entries for remote IPs (see example below)
    
        ROUTES 2
        192.168.210.0/24 ens259f0
        192.168.200.0/24 ens259f1
        
3. Configure HTTP server application 
    
    .../mtcp-devel/apps/example$ vim epserver.conf
    
    - num_cores = 4 //set the number of cores that will run mTCP
    - core_mask = 0F // bit-mask that specifies which cores to use; 0F=00001111; use cores 0-3
    - num_tx_desc = 512 //set TX descriptor ring size
    - num_rx_desc = 128 //set RX descriptor ring size
    - port = p0 //set the port that should be mapped for mTCP
    - stat_print = p0 //set the ports for which stats should be printed

    You can configure other parameters too for optimized performance
2. Configure HTTP client application 
        ..../mtcp-devel/apps/example$ vim epwget.conf

    Configure the client-side mTCP for the parameters listed in step (1)
    
### Execute mTCP sample application "HTTP server"
1. Configure the RTE vars
    
    $ export RTE_SDK = \<absolute-path-to-dpdk-stable-19.11.8\>
    
    $ export RTE_TARGET = \<target\>

2. For mTCP based HTTP server
    a. Create a directory where files that are requested for transfer are stored
    b. Run the HTTP server
        
    .../mtcp-devel/apps/example$ sudo ./epserver -p \<absolute-path-to-www-dir\> -f epserver.conf [-N \<num-cores\>]
    
    Example:

    ~/mtcp-devel/apps/example$ sudo ./epserver -p /home/ubuntu/www -f epserver.conf -N 2
3. For mTCP based HTTP client

    .../mtcp-devel/apps/example$ sudo ./epwget <server-IP>/<file-name> <num_requests> [-N #cores] [-c concurrency] -f epwget.conf

    Example:

    ~/mtcp-devel/apps/example$ sudo ./epwget 192.168.220.35/example.txt 10000000 -N 8 -c 10000 -f epwget.conf
    

    
